﻿using ProjectMonorail.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMonorail.Drawnings;
public class DrawningLocomotiveCompareByColor : IComparer<DrawningLocomotive?>
{
    public int Compare(DrawningLocomotive? x, DrawningLocomotive? y)
    {
        // TODO прописать логику сравения по цветам, скорости, весу
        if (x == null || x.EntityLocomotive == null)
        {
            return 1;
        }
        if (y == null || y.EntityLocomotive == null)
        {
            return -1;
        }
        var bodyColorCompare = y.EntityLocomotive.BodyColor.Name.CompareTo(x.EntityLocomotive.BodyColor.Name);
        if (bodyColorCompare != 0)
        {
            return bodyColorCompare;
        }
        if (x is DrawningMonorail && y is DrawningMonorail)
        {
            var additionalColorCompare = (y.EntityLocomotive as EntityMonorail).AdditionalColor.Name.CompareTo(
                (x.EntityLocomotive as EntityMonorail).AdditionalColor.Name);
            if (additionalColorCompare != 0)
            {
                return additionalColorCompare;
            }
        }
        var speedCompare = y.EntityLocomotive.Speed.CompareTo(x.EntityLocomotive.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityLocomotive.Weight.CompareTo(x.EntityLocomotive.Weight);
    }
}