﻿using ProjectMonorail.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMonorail.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningLocomotiveEqutables : IEqualityComparer<DrawningLocomotive?>
{
    public bool Equals(DrawningLocomotive? x, DrawningLocomotive? y)
    {
        if (x == null || x.EntityLocomotive == null)
        {
            return false;
        }
        if (y == null || y.EntityLocomotive == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityLocomotive.Speed != y.EntityLocomotive.Speed)
        {
            return false;
        }
        if (x.EntityLocomotive.Weight != y.EntityLocomotive.Weight)
        {
            return false;
        }
        if (x.EntityLocomotive.BodyColor != y.EntityLocomotive.BodyColor)
        {
            return false;
        }
        if (x is DrawningMonorail && y is DrawningMonorail)
        {
            // TODO доделать логику сравнения дополнительных параметров
            if ((x.EntityLocomotive as EntityMonorail)?.AdditionalColor !=
                (y.EntityLocomotive as EntityMonorail)?.AdditionalColor)
            {
                return false;
            }
            if ((x.EntityLocomotive as EntityMonorail)?.MagneticRail !=
                (y.EntityLocomotive as EntityMonorail)?.MagneticRail)
            {
                return false;
            }
            if ((x.EntityLocomotive as EntityMonorail)?.SecondCabin !=
                (y.EntityLocomotive as EntityMonorail)?.SecondCabin)
            {
                return false;
            }
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningLocomotive? obj)
    {
        return obj.GetHashCode();
    }
}
